/***************************************************************************
*
*	File name : clg_api.h
*	Function  : APIs for CLG
*	Revision  :
*		08/31/2007	Nariai		First revision
*
****************************************************************************/
#ifndef	__CLG_API_H__
#define	__CLG_API_H__

#ifdef	__cplusplus
extern "C" {
#endif


// Usage of CLG
#define	CLG_FOR_UART0		0
#define	CLG_FOR_SPI			2
#define	CLG_FOR_I2C			3

// Count mode select
#define	CLG_COUNT_REPEAT	0
#define	CLG_COUNT_ONE_SHOT	1

// Input clock select
#define	CLG_INPUT_PCLK_1		0x0
#define	CLG_INPUT_PCLK_2		0x1
#define	CLG_INPUT_PCLK_4		0x2
#define	CLG_INPUT_PCLK_8		0x3
#define	CLG_INPUT_PCLK_16		0x4
#define	CLG_INPUT_PCLK_32		0x5
#define	CLG_INPUT_PCLK_64		0x6
#define	CLG_INPUT_PCLK_128		0x7
#define	CLG_INPUT_PCLK_256		0x8
#define	CLG_INPUT_PCLK_512		0x9
#define	CLG_INPUT_PCLK_1024		0xA
#define	CLG_INPUT_PCLK_2048		0xB
#define	CLG_INPUT_PCLK_4096		0xC
#define	CLG_INPUT_PCLK_8192		0xD
#define	CLG_INPUT_PCLK_16384	0xE

// CLG configuration
typedef struct {
	unsigned char	countMode;
	unsigned char	inputClockSel;
	unsigned short	reloadData;
} T_CLG_CFG;


// APIs
extern void ClgInit(unsigned char usage, T_CLG_CFG *pConfig);
extern void ClgStart(unsigned char usage);
extern void ClgStop(unsigned char usage);
extern void ClgIntHdlr(unsigned char usage);


#ifdef __cplusplus
}
#endif

#endif	// __CLG_API_H__
