/***************************************************************************
*
*	File name : clg_drv.h
*	Function  : Definition for CLG
*	Revision  :
*		08/31/2007	Nariai		First revision
*
****************************************************************************/
#ifndef	__CLG_DRV_H__
#define	__CLG_DRV_H__

#ifdef	__cplusplus
extern "C" {
#endif


// Macro function

// For CLG UART 0 input clock select register
#define	ClgUart0_SetInputClkSel(x)		*((volatile unsigned short *)0x4200)	= x
#define	ClgUart0_GetInputClkSel()		*((volatile unsigned short *)0x4200)

// For CLG UART 0 reload data register
#define	ClgUart0_SetReloadData(x)		*((volatile unsigned short *)0x4202)	= x
#define	ClgUart0_GetReloadData()		*((volatile unsigned short *)0x4202)

// For CLG UART 0 counter data register
#define	ClgUart0_GetCounterData()		*((volatile unsigned short *)0x4204)

// For CLG UART 0 control register
#define	ClgUart0_SetControl(x)			*((volatile unsigned short *)0x4206)	= x
#define	ClgUart0_GetControl()			*((volatile unsigned short *)0x4206)
#define	ClgUart0_TimerRun()				*((volatile unsigned short *)0x4206)	|= 0x0001
#define	ClgUart0_TimerStop()			*((volatile unsigned short *)0x4206)	&= ~(0x0001)
#define	ClgUart0_TimerReset()			*((volatile unsigned short *)0x4206)	|= 0x0002
#define	ClgUart0_SetOneShot()			*((volatile unsigned short *)0x4206)	|= 0x0010
#define	ClgUart0_SetRepeat()			*((volatile unsigned short *)0x4206)	&= ~(0x0010)

// For CLG SPI input clock select register
#define	ClgSpi_SetInputClkSel(x)		*((volatile unsigned short *)0x4240)	= x
#define	ClgSpi_GetInputClkSel()			*((volatile unsigned short *)0x4240)

// For CLG SPI reload data register
#define	ClgSpi_SetReloadData(x)			*((volatile unsigned short *)0x4242)	= x
#define	ClgSpi_GetReloadData()			*((volatile unsigned short *)0x4242)

// For CLG SPI counter data register
#define	ClgSpi_GetCounterData()			*((volatile unsigned short *)0x4244)

// For CLG SPI control register
#define	ClgSpi_SetControl(x)			*((volatile unsigned short *)0x4246)	= x
#define	ClgSpi_GetControl()				*((volatile unsigned short *)0x4246)
#define	ClgSpi_TimerRun()				*((volatile unsigned short *)0x4246)	|= 0x0001
#define	ClgSpi_TimerStop()				*((volatile unsigned short *)0x4246)	&= ~(0x0001)
#define	ClgSpi_TimerReset()				*((volatile unsigned short *)0x4246)	|= 0x0002
#define	ClgSpi_SetOneShot()				*((volatile unsigned short *)0x4246)	|= 0x0010
#define	ClgSpi_SetRepeat()				*((volatile unsigned short *)0x4246)	&= ~(0x0010)

// For CLG I2C input clock select register
#define	ClgI2c_SetInputClkSel(x)		*((volatile unsigned short *)0x4260)	= x
#define	ClgI2c_GetInputClkSel()			*((volatile unsigned short *)0x4260)

// For CLG I2C reload data register
#define	ClgI2c_SetReloadData(x)			*((volatile unsigned short *)0x4262)	= x
#define	ClgI2c_GetReloadData()			*((volatile unsigned short *)0x4262)

// For CLG I2C counter data register
#define	ClgI2c_GetCounterData()			*((volatile unsigned short *)0x4264)

// For CLG I2C control register
#define	ClgI2c_SetControl(x)			*((volatile unsigned short *)0x4266)	= x
#define	ClgI2c_GetControl()				*((volatile unsigned short *)0x4266)
#define	ClgI2c_TimerRun()				*((volatile unsigned short *)0x4266)	|= 0x0001
#define	ClgI2c_TimerStop()				*((volatile unsigned short *)0x4266)	&= ~(0x0001)
#define	ClgI2c_TimerReset()				*((volatile unsigned short *)0x4266)	|= 0x0002
#define	ClgI2c_SetOneShot()				*((volatile unsigned short *)0x4266)	|= 0x0010
#define	ClgI2c_SetRepeat()				*((volatile unsigned short *)0x4266)	&= ~(0x0010)



#ifdef __cplusplus
}
#endif

#endif	// __CLG_DRV_H__
