/***************************************************************************
*
*	File name : inthdlr.c
*	Function  : Interrupt Handler (C17801)
*	Revision  :
*		07/31/2007	Nariai		First revision
*
****************************************************************************/


// Include File
#include	"reg_801.h"
#include	"itc_api.h"
#include	"clg_api.h"

// Prototype
void AddrErrInt(void)	__attribute__ ((interrupt_handler));
void NmiInt(void)		__attribute__ ((interrupt_handler));
void RsvInt(void)		__attribute__ ((interrupt_handler));
void Gpio0Int(void)		__attribute__ ((interrupt_handler));
void Gpio1Int(void)		__attribute__ ((interrupt_handler));
void Gpio2Int(void)		__attribute__ ((interrupt_handler));
void Gpio3Int(void)		__attribute__ ((interrupt_handler));
void MftInt(void)		__attribute__ ((interrupt_handler));
void AdcRangeInt(void)	__attribute__ ((interrupt_handler));
void AdcEndInt(void)	__attribute__ ((interrupt_handler));
void VecNo12Int(void)	__attribute__ ((interrupt_handler));
void VecNo13Int(void)	__attribute__ ((interrupt_handler));
void VecNo14Int(void)	__attribute__ ((interrupt_handler));
void VecNo15Int(void)	__attribute__ ((interrupt_handler));
void VecNo16Int(void)	__attribute__ ((interrupt_handler));
void VecNo17Int(void)	__attribute__ ((interrupt_handler));
void VecNo18Int(void)	__attribute__ ((interrupt_handler));
void VecNo19Int(void)	__attribute__ ((interrupt_handler));
void RtcInt(void)		__attribute__ ((interrupt_handler));
void T8Ch0Int(void)		__attribute__ ((interrupt_handler));
void T8Ch1Int(void)		__attribute__ ((interrupt_handler));
void T8Ch2Int(void)		__attribute__ ((interrupt_handler));
void T8Ch3Int(void)		__attribute__ ((interrupt_handler));
void LcdcInt(void)		__attribute__ ((interrupt_handler));
void SpiInt(void)		__attribute__ ((interrupt_handler));
void UsbInt(void)		__attribute__ ((interrupt_handler));
void I2sTxInt(void)		__attribute__ ((interrupt_handler));
void I2sRxInt(void)		__attribute__ ((interrupt_handler));
void RemcInt(void)		__attribute__ ((interrupt_handler));


/***************************************************************************
	AddrErrInt

	description	: Interrupt handler for "Address misaligned"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void AddrErrInt(void){

	asm("brk");

}


/***************************************************************************
	NmiInt

	description	: Interrupt handler for "NMI"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void NmiInt(void){

	asm("brk");

}


/***************************************************************************
	RsvInt

	description	: Interrupt handler for "Reserved"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void RsvInt(void){

	asm("brk");

}


/***************************************************************************
	Gpio0Int

	description	: Interrupt handler for "Port input 0"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void Gpio0Int(void){

	// Clear interrupt factor
	ItcClrPort0Int();

	asm("brk");

}


/***************************************************************************
	Gpio1Int

	description	: Interrupt handler for "Port input 1"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void Gpio1Int(void){

	// Clear interrupt factor
	ItcClrPort1Int();

	asm("brk");

}


/***************************************************************************
	Gpio2Int

	description	: Interrupt handler for "Port input 2"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void Gpio2Int(void){

	// Clear interrupt factor
	ItcClrPort2Int();

	asm("brk");

}


/***************************************************************************
	Gpio3Int

	description	: Interrupt handler for "Port input 3"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void Gpio3Int(void){

	// Clear interrupt factor
	ItcClrPort3Int();

	asm("brk");

}


/***************************************************************************
	MftInt

	description	: Interrupt handler for "MFT"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void MftInt(void){

	// Clear interrupt factor
	ItcClrMftInt();

	asm("brk");

}


/***************************************************************************
	AdcRangeInt

	description	: Interrupt handler for "ADC range factor"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void AdcRangeInt(void){

	// Clear interrupt factor
	ItcClrAdcRangeInt();

	asm("brk");

}


/***************************************************************************
	AdcEndInt

	description	: Interrupt handler for "ADC end factor"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void AdcEndInt(void){

	// Clear interrupt factor
	ItcClrAdcEndInt();

	asm("brk");

}


/***************************************************************************
	VecNo12Int

	description	: Interrupt handler for "Vector No.12"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo12Int(void){

	ClgIntHdlr(CLG_FOR_UART0);
	
	// Clear interrupt factor
	ItcClrClgT16UInt();
//	ItcClrPort4Int();
	
//	asm("brk");

}


/***************************************************************************
	VecNo13Int

	description	: Interrupt handler for "Vector No.13"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo13Int(void){

	// Clear interrupt factor
	ItcClrPort5Int();

	asm("brk");

}


/***************************************************************************
	VecNo14Int

	description	: Interrupt handler for "Vector No.14"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo14Int(void){

	ClgIntHdlr(CLG_FOR_SPI);
	
	// Clear interrupt factor
	ItcClrClgT8SInt();
//	ItcClrPort6Int();

//	asm("brk");

}


/***************************************************************************
	VecNo15Int

	description	: Interrupt handler for "Vector No.15"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo15Int(void){

	ClgIntHdlr(CLG_FOR_I2C);

	// Clear interrupt factor
	ItcClrClgT8IInt();
//	ItcClrPort7Int();

//	asm("brk");

}


/***************************************************************************
	VecNo16Int

	description	: Interrupt handler for "Vector No.16"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo16Int(void){

	// Clear interrupt factor
	ItcClrUartInt();
//	ItcClrPort4Int();

}


/***************************************************************************
	VecNo17Int

	description	: Interrupt handler for "Vector No.17"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo17Int(void){

	// Clear interrupt factor
	ItcClrPort5Int();

	asm("brk");

}


/***************************************************************************
	VecNo18Int

	description	: Interrupt handler for "Vector No.18"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo18Int(void){

	// Clear interrupt factor
//	ItcClrSpiInt();
//	ItcClrPort6Int();

	asm("brk");

}


/***************************************************************************
	VecNo19Int

	description	: Interrupt handler for "Vector No.19"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void VecNo19Int(void){
//	extern void i2cInt(void);

	// Clear interrupt factor
	ItcClrI2cInt();

	// Check i2c interrupt
//	i2cInt();

//	ItcClrPort7Int();

	asm("brk");

}


/***************************************************************************
	RtcInt

	description	: Interrupt handler for "RTC"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void RtcInt(void){

	// Clear interrupt factor
	ItcClrRtcInt();

	asm("brk");

}


/***************************************************************************
	T8Ch0Int

	description	: Interrupt handler for "T8 ch.0"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void T8Ch0Int(void){

	// Clear interrupt factor
	ItcClrT8Ch0Int();

//	T8IntProc(T8_CH_0);
	
	//asm("brk");

}


/***************************************************************************
	T8Ch1Int

	description	: Interrupt handler for "T8 ch.1"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void T8Ch1Int(void){

	// Clear interrupt factor
	ItcClrT8Ch1Int();
	
//	T8IntProc(T8_CH_1);
	
	//asm("brk");

}


/***************************************************************************
	T8Ch2Int

	description	: Interrupt handler for "T8 ch.2"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void T8Ch2Int(void){

	// Clear interrupt factor
	ItcClrT8Ch2Int();

//	T8IntProc(T8_CH_2);
	
	//asm("brk");

}


/***************************************************************************
	T8Ch3Int

	description	: Interrupt handler for "T8 ch.3"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void T8Ch3Int(void){

	// Clear interrupt factor
	ItcClrT8Ch3Int();

//	T8IntProc(T8_CH_3);
	
	//asm("brk");

}


/***************************************************************************
	LcdcInt

	description	: Interrupt handler for "LCDC"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void LcdcInt(void){

	// Clear interrupt factor
	ItcClrLcdcInt();

	asm("brk");

}


/***************************************************************************
	SpiInt

	description	: Interrupt handler for "SPI"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void SpiInt(void){

	// Clear interrupt factor
	ItcClrEspiInt();

	asm("brk");

}


/***************************************************************************
	UsbInt

	description	: Interrupt handler for "USB"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void UsbInt(void){

	// Clear interrupt factor
	ItcClrUsbInt();

	asm("brk");

}


/***************************************************************************
	I2sTxInt

	description	: Interrupt handler for "I2S FIFO Empty"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void I2sTxInt(void){

	// Clear interrupt factor
	ItcClrI2sTranInt();

	asm("brk");
}


/***************************************************************************
	I2sRxInt

	description	: Interrupt handler for "I2S FIFO Full"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void I2sRxInt(void){

	// Clear interrupt factor
	ItcClrI2sRcvInt();

	asm("brk");

}


/***************************************************************************
	RemcInt

	description	: Interrupt handler for "REMC"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void RemcInt(void){

	// Clear interrupt factor
	ItcClrRemcInt();

	asm("brk");

}

