/***************************************************************************
*
*	File name : itc_drv.c
*	Function  : ITC Driver
*	Revision  :
*		10/04/2007	Nariai		First revision
*
****************************************************************************/


// Include Files
#include	"reg_801.h"
#include	"system.h"
#include	"itc_api.h"


// Prototype
void ItcInit(T_ITC_CFG *pConfig);


/***************************************************************************
	ItcInit

	description	: Initialize ITC
	argument	: pConfig	: pointer of ITC configuration info.
	return: 	: None

***************************************************************************/
void ItcInit(T_ITC_CFG *pConfig){

	// Clear all interrupt factor
	ItcClrAddIntFlag(0xFFFF);
	ItcClrIntFlag(0xFFFF);

	// Setting interrupt enable
	ItcSetAddIntEnable(pConfig->addIntEn.reg);
	ItcSetIntEnable(pConfig->intEn.reg);

	// Setting additional interrupt level
	ItcSetAddIntLv0(pConfig->addIntLv0.reg);
	ItcSetAddIntLv1(pConfig->addIntLv1.reg);
	ItcSetAddIntLv2(pConfig->addIntLv2.reg);
	ItcSetAddIntLv3(pConfig->addIntLv3.reg);
	ItcSetAddIntLv4(pConfig->addIntLv4.reg);
	ItcSetAddIntLv5(pConfig->addIntLv5.reg);
	ItcSetAddIntLv6(pConfig->addIntLv6.reg);
	ItcSetAddIntLv7(pConfig->addIntLv7.reg);

	// Setting interrupt level
	ItcSetExtIntLv0(pConfig->extIntLv0.reg);
	ItcSetExtIntLv1(pConfig->extIntLv1.reg);
	ItcSetExtIntLv2(pConfig->extIntLv2.reg);
	ItcSetExtIntLv3(pConfig->extIntLv3.reg);
	ItcSetInIntLv0(pConfig->inIntLv0.reg);
	ItcSetInIntLv1(pConfig->inIntLv1.reg);
	ItcSetInIntLv2(pConfig->inIntLv2.reg);
	ItcSetInIntLv3(pConfig->inIntLv3.reg);

	if(pConfig->funcEnable == ITC_FUNC_ENABLE){
		ItcFuncEnable();
	} else {
		ItcFuncDisable();
	}

	return;

}

